]> Pileus Git - ~andy/git/blob - git-rebase.sh
scripts: Add placeholders for OPTIONS_SPEC
[~andy/git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
12
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
19
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.  You must be in the top
22 directory of your project to start (or continue) a rebase.
23
24 Example:       git-rebase master~1 topic
25
26         A---B---C topic                   A'\''--B'\''--C'\'' topic
27        /                   -->           /
28   D---E---F---G master          D---E---F---G master
29 '
30
31 SUBDIRECTORY_OK=Yes
32 OPTIONS_SPEC=
33 . git-sh-setup
34 set_reflog_action rebase
35 require_work_tree
36 cd_to_toplevel
37
38 RESOLVEMSG="
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
42 "
43 unset newbase
44 strategy=recursive
45 do_merge=
46 dotest=$GIT_DIR/.dotest-merge
47 prec=4
48 verbose=
49 git_am_opt=
50
51 continue_merge () {
52         test -n "$prev_head" || die "prev_head must be defined"
53         test -d "$dotest" || die "$dotest directory does not exist"
54
55         unmerged=$(git ls-files -u)
56         if test -n "$unmerged"
57         then
58                 echo "You still have unmerged paths in your index"
59                 echo "did you forget to use git add?"
60                 die "$RESOLVEMSG"
61         fi
62
63         cmt=`cat "$dotest/current"`
64         if ! git diff-index --quiet HEAD
65         then
66                 if ! git-commit -C "$cmt"
67                 then
68                         echo "Commit failed, please do not call \"git commit\""
69                         echo "directly, but instead do one of the following: "
70                         die "$RESOLVEMSG"
71                 fi
72                 printf "Committed: %0${prec}d " $msgnum
73         else
74                 printf "Already applied: %0${prec}d " $msgnum
75         fi
76         git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
77
78         prev_head=`git rev-parse HEAD^0`
79         # save the resulting commit so we can read-tree on it later
80         echo "$prev_head" > "$dotest/prev_head"
81
82         # onto the next patch:
83         msgnum=$(($msgnum + 1))
84         echo "$msgnum" >"$dotest/msgnum"
85 }
86
87 call_merge () {
88         cmt="$(cat "$dotest/cmt.$1")"
89         echo "$cmt" > "$dotest/current"
90         hd=$(git rev-parse --verify HEAD)
91         cmt_name=$(git symbolic-ref HEAD)
92         msgnum=$(cat "$dotest/msgnum")
93         end=$(cat "$dotest/end")
94         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
95         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
96         export GITHEAD_$cmt GITHEAD_$hd
97         git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
98         rv=$?
99         case "$rv" in
100         0)
101                 unset GITHEAD_$cmt GITHEAD_$hd
102                 return
103                 ;;
104         1)
105                 git rerere
106                 die "$RESOLVEMSG"
107                 ;;
108         2)
109                 echo "Strategy: $rv $strategy failed, try another" 1>&2
110                 die "$RESOLVEMSG"
111                 ;;
112         *)
113                 die "Unknown exit code ($rv) from command:" \
114                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
115                 ;;
116         esac
117 }
118
119 finish_rb_merge () {
120         rm -r "$dotest"
121         echo "All done."
122 }
123
124 is_interactive () {
125         test -f "$dotest"/interactive ||
126         while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
127                 shift
128         done && test -n "$1"
129 }
130
131 is_interactive "$@" && exec git-rebase--interactive "$@"
132
133 while test $# != 0
134 do
135         case "$1" in
136         --continue)
137                 git diff-files --quiet || {
138                         echo "You must edit all merge conflicts and then"
139                         echo "mark them as resolved using git add"
140                         exit 1
141                 }
142                 if test -d "$dotest"
143                 then
144                         prev_head=$(cat "$dotest/prev_head")
145                         end=$(cat "$dotest/end")
146                         msgnum=$(cat "$dotest/msgnum")
147                         onto=$(cat "$dotest/onto")
148                         continue_merge
149                         while test "$msgnum" -le "$end"
150                         do
151                                 call_merge "$msgnum"
152                                 continue_merge
153                         done
154                         finish_rb_merge
155                         exit
156                 fi
157                 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
158                 exit
159                 ;;
160         --skip)
161                 if test -d "$dotest"
162                 then
163                         git rerere clear
164                         prev_head=$(cat "$dotest/prev_head")
165                         end=$(cat "$dotest/end")
166                         msgnum=$(cat "$dotest/msgnum")
167                         msgnum=$(($msgnum + 1))
168                         onto=$(cat "$dotest/onto")
169                         while test "$msgnum" -le "$end"
170                         do
171                                 call_merge "$msgnum"
172                                 continue_merge
173                         done
174                         finish_rb_merge
175                         exit
176                 fi
177                 git am -3 --skip --resolvemsg="$RESOLVEMSG"
178                 exit
179                 ;;
180         --abort)
181                 git rerere clear
182                 if test -d "$dotest"
183                 then
184                         rm -r "$dotest"
185                 elif test -d .dotest
186                 then
187                         rm -r .dotest
188                 else
189                         die "No rebase in progress?"
190                 fi
191                 git reset --hard ORIG_HEAD
192                 exit
193                 ;;
194         --onto)
195                 test 2 -le "$#" || usage
196                 newbase="$2"
197                 shift
198                 ;;
199         -M|-m|--m|--me|--mer|--merg|--merge)
200                 do_merge=t
201                 ;;
202         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
203                 --strateg=*|--strategy=*|\
204         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
205                 case "$#,$1" in
206                 *,*=*)
207                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
208                 1,*)
209                         usage ;;
210                 *)
211                         strategy="$2"
212                         shift ;;
213                 esac
214                 do_merge=t
215                 ;;
216         -v|--verbose)
217                 verbose=t
218                 ;;
219         --whitespace=*)
220                 git_am_opt="$git_am_opt $1"
221                 ;;
222         -C*)
223                 git_am_opt="$git_am_opt $1"
224                 ;;
225         -*)
226                 usage
227                 ;;
228         *)
229                 break
230                 ;;
231         esac
232         shift
233 done
234
235 # Make sure we do not have .dotest
236 if test -z "$do_merge"
237 then
238         if mkdir .dotest
239         then
240                 rmdir .dotest
241         else
242                 echo >&2 '
243 It seems that I cannot create a .dotest directory, and I wonder if you
244 are in the middle of patch application or another rebase.  If that is not
245 the case, please rm -fr .dotest and run me again.  I am stopping in case
246 you still have something valuable there.'
247                 exit 1
248         fi
249 else
250         if test -d "$dotest"
251         then
252                 die "previous dotest directory $dotest still exists." \
253                         'try git-rebase < --continue | --abort >'
254         fi
255 fi
256
257 # The tree must be really really clean.
258 git update-index --refresh || exit
259 diff=$(git diff-index --cached --name-status -r HEAD)
260 case "$diff" in
261 ?*)     echo "cannot rebase: your index is not up-to-date"
262         echo "$diff"
263         exit 1
264         ;;
265 esac
266
267 # The upstream head must be given.  Make sure it is valid.
268 upstream_name="$1"
269 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
270     die "invalid upstream $upstream_name"
271
272 # Make sure the branch to rebase onto is valid.
273 onto_name=${newbase-"$upstream_name"}
274 onto=$(git rev-parse --verify "${onto_name}^0") || exit
275
276 # If a hook exists, give it a chance to interrupt
277 if test -x "$GIT_DIR/hooks/pre-rebase"
278 then
279         "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
280                 echo >&2 "The pre-rebase hook refused to rebase."
281                 exit 1
282         }
283 fi
284
285 # If the branch to rebase is given, first switch to it.
286 case "$#" in
287 2)
288         branch_name="$2"
289         git-checkout "$2" || usage
290         ;;
291 *)
292         if branch_name=`git symbolic-ref -q HEAD`
293         then
294                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
295         else
296                 branch_name=HEAD ;# detached
297         fi
298         ;;
299 esac
300 branch=$(git rev-parse --verify "${branch_name}^0") || exit
301
302 # Now we are rebasing commits $upstream..$branch on top of $onto
303
304 # Check if we are already based on $onto with linear history,
305 # but this should be done only when upstream and onto are the same.
306 mb=$(git merge-base "$onto" "$branch")
307 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
308         # linear history?
309         ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
310 then
311         echo >&2 "Current branch $branch_name is up to date."
312         exit 0
313 fi
314
315 if test -n "$verbose"
316 then
317         echo "Changes from $mb to $onto:"
318         # We want color (if set), but no pager
319         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
320 fi
321
322 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
323 echo "First, rewinding head to replay your work on top of it..."
324 git-reset --hard "$onto"
325
326 # If the $onto is a proper descendant of the tip of the branch, then
327 # we just fast forwarded.
328 if test "$mb" = "$branch"
329 then
330         echo >&2 "Fast-forwarded $branch_name to $onto_name."
331         exit 0
332 fi
333
334 if test -z "$do_merge"
335 then
336         git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
337         git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
338         exit $?
339 fi
340
341 # start doing a rebase with git-merge
342 # this is rename-aware if the recursive (default) strategy is used
343
344 mkdir -p "$dotest"
345 echo "$onto" > "$dotest/onto"
346 echo "$onto_name" > "$dotest/onto_name"
347 prev_head=`git rev-parse HEAD^0`
348 echo "$prev_head" > "$dotest/prev_head"
349
350 msgnum=0
351 for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
352 do
353         msgnum=$(($msgnum + 1))
354         echo "$cmt" > "$dotest/cmt.$msgnum"
355 done
356
357 echo 1 >"$dotest/msgnum"
358 echo $msgnum >"$dotest/end"
359
360 end=$msgnum
361 msgnum=1
362
363 while test "$msgnum" -le "$end"
364 do
365         call_merge "$msgnum"
366         continue_merge
367 done
368
369 finish_rb_merge